// IRScopeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IRScope.h"
#include "IRScopeDlg.h"
#include "IRScopeWnd.h"
#include "widget.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIRScopeDlg dialog

CIRScopeDlg::CIRScopeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIRScopeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIRScopeDlg)
	m_Duration = 3000;
	m_Port = _T("COM1");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIRScopeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIRScopeDlg)
	DDX_Text(pDX, IDC_DURATION, m_Duration);
	DDV_MinMaxUInt(pDX, m_Duration, 500, 10000);
	DDX_CBString(pDX, IDC_PORT, m_Port);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIRScopeDlg, CDialog)
	//{{AFX_MSG_MAP(CIRScopeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIRScopeDlg message handlers

BOOL CIRScopeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CIRScopeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIRScopeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIRScopeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CIRScopeDlg::OnCapture() 
{
	if(!UpdateData())
		return;

	CWaitCursor wait;

	int err=OpenPort(m_Port);

	CString s;
	if(err) {
		s.Format("Unable to open %s\nError %i",m_Port,err);
		MessageBox(s);
		return;
	}

	const UINT sample_byte_count = m_Duration * 1000 / 100;

	BYTE* data=new BYTE[sample_byte_count];
	if(!data) return;

	MessageBeep(MB_OK);

	const UINT read=ReadPort(sample_byte_count,data);
	TRACE("%i Bytes Read\n",read);

	ClosePort();

	if(read!=sample_byte_count) {
		s.Format("Expected %i bytes, only got %i",sample_byte_count,read);
		MessageBox(s);
	}

	//if(!read) {
	if(read<100) {
		delete[] data;
		return;
	}

	int count;
	int* times;
	short int* counts;
	UINT freq;
	err=ProcessData(read,data,count,times,counts,freq);
	if(err==0) {
		WriteFile("irscope.txt",count,times,counts);
		CIrScopeWnd* wnd=new CIrScopeWnd;
		wnd->Create(::GetDesktopWindow());
		wnd->SetData(count,times,counts);
		CString fs;
		fs.Format("%i Hz",freq);
		wnd->SetText(fs);
	} else if(err==1) {
		MessageBox("No signal found");
	} else if(err==2) {
		MessageBox("Bogus data");
	}

	delete[] data;
}


